import QtQuick 2.1
import QtQuick.Dialogs 1.0
import QtQuick.Controls 1.0
import MuseScore 1.0

MuseScore {
    menuPath: "Plugins.Copy Staff"
    version: "2.0"
    description: qsTr("Плагин может скопировать на один нотный стан до 4 нотных станов. В разные голоса... Копируется только первый голос.")
    pluginType: "dialog"

    id:window
    width:  250; height: 200;
    onRun: {
        if (typeof curScore === 'undefined'){
            Qt.quit();}
        }

    function copyVoice(){
        var cursor = curScore.newCursor()
        var voiceInIndex = + voiceIn.text - 1
        var staffOutIndex = + staffOut.text - 1
        var staffInIndex = + staffIn.text - 1
        cursor.voice = 0
        cursor.staffIdx = staffOutIndex
        cursor.rewind(0)

        while (cursor.segment) {
            var CopyElement = cursor.element.clone()
            //Приемник
            cursor.voice = voiceInIndex
            cursor.staffIdx = staffInIndex
            cursor.add(CopyElement)
            //Источник
            cursor.voice = 0
            cursor.staffIdx = staffOutIndex
            cursor.next()
            }
        }
TextField {
        id: staffOut
        text: "1"
        validator: IntValidator{bottom: 1; top: curScore.nstaves;}
        anchors.right: window.right
        anchors.top: textHeader.bottom
        anchors.rightMargin: 5
        anchors.topMargin: 5
        width: 50
        }

    TextField {
        id: staffIn
        text: curScore.nstaves
        validator: IntValidator{bottom: 1; top: curScore.nstaves;}
        anchors.right: window.right
        anchors.top: staffOut.bottom
        anchors.rightMargin: 5
        anchors.topMargin: 5
        width: 50
        }

    TextField {
        id: voiceIn
        text: "1"
        //placeholderText: qsTr("Voice")
        validator: IntValidator{bottom: 1; top: 4;}
        anchors.right: window.right
        anchors.top: staffIn.bottom
        anchors.rightMargin: 5
        anchors.topMargin: 5
        width: 50
        }

    Label {
        id: textHeader
        wrapMode: Text.WordWrap
        text: qsTr("Копирование голоса")
        font.pointSize:13
        anchors.left: window.left
        anchors.top: window.top
        anchors.leftMargin: 5
        anchors.topMargin: 10
        }

    Label {
        id: textOut
        wrapMode: Text.WordWrap
        text: qsTr("Нотный стан Источник:")
        font.pointSize:10
        anchors.left: window.left
        anchors.top: textHeader.bottom
        anchors.leftMargin: 5
        anchors.topMargin: 6
        }

    Label {
        id: textIn
        wrapMode: Text.WordWrap
        text: qsTr("Нотный стан Приемник:")
        font.pointSize:10
        anchors.left: window.left
        anchors.top: textOut.bottom
        anchors.leftMargin: 5
        anchors.topMargin: 6
        }

    Label {
        id: textVoice
        wrapMode: Text.WordWrap
        text: qsTr("Голос:")
        font.pointSize:10
        anchors.left: window.left
        anchors.top: textIn.bottom
        anchors.leftMargin: 5
        anchors.topMargin: 6
        }

    Button {
        id : buttonOK
        width: 75
        text: qsTr("OK")
        anchors.bottom: window.bottom
        anchors.right: buttonCancel.left
        anchors.bottomMargin: 5
        anchors.rightMargin: 5
        onClicked: {
            copyVoice()
            curScore.doLayout()
            Qt.quit()
            }
        }

    Button {
        id : buttonCancel
        width: 75
        text: qsTr("Отмена")
        anchors.bottom: window.bottom
        anchors.right: window.right
        anchors.bottomMargin: 5
        anchors.rightMargin: 5
        onClicked: {
            Qt.quit()
            }
        }

    }
